//̓f[^H
//Revised on 11:37 05/08/20,, Data Generator, 23bit-M-series
//pfd_outp,pfd_outn :: signed-integer, 4bit-over + 20bit-core

module dat_gen(rst,clk,datp,datn);
	input rst,clk;
	output datp,datn;
	reg x_prbs[1:23];
	wire datp,datn,dat;

	assign dat=x_prbs[23];
	assign datp=dat;
	assign datn=~dat;

	integer index;

	always @ (clk or posedge rst) begin
		if(rst==1'b1) begin
			for(index=1;index<24;index=index+1) 
				x_prbs[index] <= 1'b1;
		end else begin
			for(index=1;index<23;index=index+1) begin
				x_prbs[24-index] <= x_prbs[23-index];
			end
			x_prbs[1] <= (x_prbs[18] ^ x_prbs[23]);
		end
	end

endmodule
