//fBW^xH
//Revised on 15:26 05/09/24,,, Digital Delay
//in, out :: 1bit

module dgtl_dly(in,out,vdd,vss);
	input vdd,vss;
	input in;
	output out;
	reg out;
	reg cnt_strt;//CounterJntOB
	reg [1:50] in_pr;//1`50clockOinlB

	integer cycle, tmp_i1, tmp_i2;
	integer k_div2;
	integer cnt_tdrf, cntup_trf;
	integer ind;
	real tmp_r1, tmp_r2;

	parameter TM_PRCS=0.001;//[nsec]AԒPʁB
	parameter TD=0.2;//[nsec]AxԁB
	parameter TRF=0.2;//[nsec]AE莞ԁB
	parameter K_DIV=50;//(TD+TRF)/K_DIVlTCN(cycle)ƂB

	initial begin
		tmp_i1=K_DIV;
		k_div2=(tmp_i1 > 50)? 50:tmp_i1;//Limitter for K_DIV

		tmp_r1=(TD+TRF)/(k_div2*TM_PRCS);
		tmp_i1=tmp_r1;
		cycle=(tmp_i1 < 1)? 1: tmp_i1;

		tmp_r1=cycle;
		tmp_r2=TRF/(tmp_r1*TM_PRCS);
		tmp_i1=tmp_r2;
		cntup_trf=(tmp_i1 < 1)? 1: tmp_i1;

		cnt_tdrf=0;
		cnt_strt=1'b0;
	end

	always # (cycle) begin

		for(ind=1;ind<k_div2;ind=ind+1) in_pr[ind] <= in_pr[ind+1];//in̒xB
		in_pr[k_div2] <= in;
		out <= in_pr[1];

		if(cnt_strt==1'b0) begin
			cnt_tdrf=0;
			tmp_i1=(in==in_pr[k_div2])? 0:1;
		end else begin
			cnt_tdrf=cnt_tdrf +1;

			if(cnt_tdrf < cntup_trf) begin
				if(in==in_pr[k_div2]) 
					tmp_i1=1;
				else begin
					tmp_i1=0;
					for(ind=1;ind<=cnt_tdrf;ind=ind+1) //cntup_trf̎pX폜B
						in_pr[k_div2-ind] <= in;
				end
			end else
				tmp_i1=0;
		end
		cnt_strt <= tmp_i1;
	end

endmodule
