//ʑEgoH + fBW^xH
//Revised on 22:26 05/09/25
//pd1_outp, pd1_outn, fd_outp, fd_outn :: 1bit-data

`include "pfd.v"
`include "dgtl_dly.v"

module pfd_top (rst, datp, datn, ck0p, ck0n, ck45p, ck45n, ck90p, ck90n, ck135p, ck135n,
			pd1_outp, pd1_outn, fd_outp, fd_outn, vdd, vss);
	input rst, datp, datn, ck0p, ck0n, ck45p, ck45n, ck90p, ck90n,
		ck135p, ck135n;
	input vdd, vss;
	output pd1_outp, pd1_outn, fd_outp, fd_outn;
	wire pd1_outp, pd1_outn, pd1_outp1, pd1_outn1;
	wire fd_outp, fd_outn, fd_outp1, fd_outn1;

	//I2`I5idgtl_dlyjpp[^
	parameter TM_PRCS=0.001;//[nsec]AԒPʁB

	//I2I3itwo dgtl_dlyjpp[^
	parameter TD_PD1=0.2;//[nsec], xԁB
	parameter TRF_PD1=0.2;//[nsec], E莞ԁB
	parameter K_DIV_PD1=50;//(TD+TRF)/K_DIVlTCN(cycle)ƂBPDpB

	//I4I5itwo dgtl_dlyjpp[^
	parameter TD_FD=0.2;//[nsec], xԁB
	parameter TRF_FD=0.2;//[nsec], E莞ԁB
	parameter K_DIV_FD=50;//(TD+TRF)/K_DIVlTCN(cycle)ƂBFDpB

	defparam I2.TM_PRCS=TM_PRCS;
	defparam I2.TD=TD_PD1;
	defparam I2.TRF=TRF_PD1;
	defparam I2.K_DIV=K_DIV_PD1;

	defparam I3.TM_PRCS=TM_PRCS;
	defparam I3.TD=TD_PD1;
	defparam I3.TRF=TRF_PD1;
	defparam I3.K_DIV=K_DIV_PD1;

	defparam I4.TM_PRCS=TM_PRCS;
	defparam I4.TD=TD_FD;
	defparam I4.TRF=TRF_FD;
	defparam I4.K_DIV=K_DIV_FD;

	defparam I5.TM_PRCS=TM_PRCS;
	defparam I5.TD=TD_FD;
	defparam I5.TRF=TRF_FD;
	defparam I5.K_DIV=K_DIV_FD;

	//Netlist
	pfd I1 (rst, datp, datn, ck0p, ck0n, ck45p, ck45n, ck90p, ck90n, ck135p, ck135n,
			pd1_outp1, pd1_outn1, fd_outp1, fd_outn1, vdd, vss);
	dgtl_dly I2 (pd1_outp1,pd1_outp,vdd,vss);
	dgtl_dly I3 (pd1_outn1,pd1_outn,vdd,vss);
	dgtl_dly I4 (fd_outp1,fd_outp,vdd,vss);
	dgtl_dly I5 (fd_outn1,fd_outn,vdd,vss);

endmodule
