//f[^ĐH
//Revised on 18:40 05/08/11
//rst,ckp,ckn,dat_inp,dat_inn,dat_outp,dat_outn :: 1bit

module re_time(rst,ckp,ckn,dat_inp,dat_inn,dat_outp,dat_outn,vdd,vss);
	input rst,ckp,ckn,dat_inp,dat_inn;
	input vdd,vss;
	output dat_outp,dat_outn;
	reg dat_out;
	wire dat_outp,dat_outn,ck,dat_in;

	assign dat_outp=(dat_out==1'b0)? 1'b0 : 1'b1;
	assign dat_outn=~dat_outp;
	assign ck=(ckp==~ckn)? ckp : 1'b0;
	assign dat_in=(dat_inp==~dat_inn)? dat_inp : dat_inn;

	always @ (posedge ck or negedge ck) begin
		if(rst==1'b1)
			dat_out <= 1'b0;
		else
			dat_out <= dat_in;
	end

endmodule
