//CDRHigbvHj
//Revised on 00:24 05/10/08

//`include "pfd_top.v"
//`include "cp_lpf.v"
//`include "vco_chn.v"
//`include "re_time.v"
`timescale 1ps / 1ps

module top (rst, datp, datn, outp, outn, ckgenp, ckgenn, clf_out, vdd, vss);
	input rst, datp, datn;
	input vdd, vss;
	output outp, outn;
	output ckgenp, ckgenn;//NbNŁAf[^𐶐郊t@XNbNƂ90degʑقȂ(clk_gen45)B
	output [23:0] clf_out;
	wire pd1p, pd1n, fdp, fdn;
	wire ck0p, ck0n, ck45p, ck45n, ck90p, ck90n, ck135p, ck135n;
	wire [23:0] clf_out;

	// I1`I3ipfd_top, cp_lpf, vco_chnjpp[^
	parameter TM_PRCS=0.001;//[nsec], ԐxB
	
	//I2I3icp_lpf, vco_chnjpp[^
	parameter K_RTOI=524288.0;//realϐintegerϐ֕ϊWB

	//I1ipfd_topjpp[^
	parameter TD_PD1=1.0;//[nsec], xԁBPDpB
	parameter TRF_PD1=0.2;//[nsec], E莞ԁBPDpB
	parameter K_DIV_PD1=50;//(TD+TRF)/K_DIVlTCN(cycle)ƂBPDpB
	parameter TD_FD=1.0;//[nsec], xԁBFDpB
	parameter TRF_FD=0.2;//[nsec], E莞ԁBFDpB
	parameter K_DIV_FD=50;//(TD+TRF)/K_DIVlTCN(cycle)ƂBFDpB

	//I2icp_lpfjpp[^
	parameter CUR_CP_PD1=5.0;//[uA]BCharge-Pump̓dlBPDpB
	parameter RTO_B_A_PD1=1.0;//Charge-Pumpł̋z݂Ɠfod̔䗦(Un-match̉ex)BPDpB
	parameter CUR_CP_FD=5.0;//[uA]BCharge-Pump̓dlBFDpB
	parameter RTO_B_A_FD=1.0;//Charge-Pumpł̋z݂Ɠfod̔䗦(Un-match̉ex)BFDpB
	parameter OFS_CUR_CP_FD=0.0;//[uA]Bԃx͂łCharge-Pump̓dlBFDpB
	parameter CP=8.0;//[pF]BLPFł̃LpV^litB^萔jB
	parameter C2=0.2;//[pF]BCharge-Pumpؑւ莞̃tB[hX[ɘapLpV^lBLPFŎgpB
	parameter RP=1000.0;//[Ohm]BLPFł̒RlitB^萔jB
	parameter TS_RK_LPF=0.001;//[nsec]BQNb^̎BLPFpB
	parameter N_STP_INI_LPF=0.1;//[nsec]BQNb^vZ̃Xebv̏liCPo͂̍XV̏ljB
	parameter RELERR_LPF=0.001;//e΃G[iQNb^vZjB
	parameter ABSERR_LPF=0.00001;//e΃G[iQNb^vZjB

	//I3ivco_chnjpp[^
	parameter CYCLE_VCO=1;//VCOł̏o͍XVԁi=TM_PRCS*CYCLE_VCOjB
	parameter THETA_INIT=0.0;//[rad]AVCOł̏ʑB

	defparam I1.TM_PRCS=TM_PRCS;
	defparam I1.TD_PD1=TD_PD1;
	defparam I1.TRF_PD1=TRF_PD1;
	defparam I1.K_DIV_PD1=K_DIV_PD1;
	defparam I1.TD_FD=TD_FD;
	defparam I1.TRF_FD=TRF_FD;
	defparam I1.K_DIV_FD=K_DIV_FD;
	
	defparam I2.TM_PRCS=TM_PRCS;
	defparam I2.K_RTOI=K_RTOI;
	defparam I2.CUR_CP_PD1=CUR_CP_PD1;
	defparam I2.RTO_B_A_PD1=RTO_B_A_PD1;
	defparam I2.CUR_CP_FD=CUR_CP_FD;
	defparam I2.RTO_B_A_FD=RTO_B_A_FD;
	defparam I2.OFS_CUR_CP_FD=OFS_CUR_CP_FD;
	defparam I2.CP=CP;
	defparam I2.C2=C2;
	defparam I2.RP=RP;
	defparam I2.TS_RK=TS_RK_LPF;
	defparam I2.N_STP_INI=N_STP_INI_LPF;
	defparam I2.RELERR=RELERR_LPF;
	defparam I2.ABSERR=ABSERR_LPF;
	
	defparam I3.TM_PRCS=TM_PRCS;
	defparam I3.CYCLE_VCO=CYCLE_VCO;
	defparam I3.THETA_INIT=THETA_INIT;
	defparam I3.K_RTOI=K_RTOI;

	//---lbgXg
	assign ckgenp=ck45p;
	assign ckgenn=ck45n;
	pfd_top I1 (rst, datp, datn, ck0p, ck0n, ck45p, ck45n, ck90p, ck90n, ck135p, ck135n,
			pd1p, pd1n, fdp, fdn, vdd, vss);
	cp_lpf I2 (rst, pd1p, pd1n, fdp, fdn, clf_out, vdd, vss);
	vco_chn I3 (rst, clf_out, ck0p, ck0n, ck45p, ck45n, ck90p, ck90n, ck135p, ck135n, 
			vdd, vss);
	re_time I4 (rst, ck45p, ck45n, datp, datn, outp, outn, vdd, vss);

endmodule
